| The Gaudi Framework v29r1 (5cd95fa2)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Protected Attributes | Private Member Functions | List of all members
Gaudi::Histogram1D Class Reference

AIDA implementation for 1 D histograms using ROOT THD1. More...

`#include <GaudiCommonSvc/H1D.h>`

Inheritance diagram for Gaudi::Histogram1D:
[legend]
Collaboration diagram for Gaudi::Histogram1D:
[legend]

## Public Member Functions
| Histogram1D ()
| Standard constructor. More...
| Histogram1D (TH1D *rep)
| Standard constructor with initialization. The histogram representation will be adopted. More...
void | adoptRepresentation (TObject *rep) override
| Adopt ROOT histogram representation. More...
virtual bool | setBinContents (int i, int entries, double height, double error, double centre)
| set bin content (entries and centre are not used ) More...
bool | reset () override
| need to overwrite reset to reset the sums More...
virtual bool | setStatistics (int allEntries, double eqBinEntries, double mean, double rms)
| set histogram statistics More...
bool | fill (double x, double weight) override
| Fill the Profile1D with a value and the corresponding weight. More...
bool | setRms (double rms)
| Update histogram RMS. More...
void | copyFromAida (const AIDA::IHistogram1D &h)
| Create new histogram from any AIDA based histogram. More...
const CLID & | clID () const override
| Retrieve reference to class defininition identifier. More...
StreamBuffer & | serialize (StreamBuffer &s)
| Serialization mechanism, Serialize the object for reading. More...
StreamBuffer & | serialize (StreamBuffer &s) const
| Serialization mechanism, Serialize the object for writing. More...
Public Member Functions inherited from DataObject
| DataObject ()
| Standard Constructor. More...
| DataObject (const DataObject &rhs)
| Copy Constructor. More...
DataObject & | operator= (const DataObject &rhs)
| Assignment Operator. More...
| DataObject (DataObject &&rhs)
| Move Constructor. More...
DataObject & | operator= (DataObject &&rhs)
| Move Assignment Operator. More...
virtual | ~DataObject ()
| Standard Destructor. More...
virtual unsigned long | addRef ()
| Add reference to object. More...
virtual unsigned long | release ()
| release reference to object More...
const std::string & | name () const
| Retreive DataObject name. It is the name when registered in the store. More...
virtual StatusCode | update ()
| Provide empty placeholder for internal object reconfiguration callback. More...
void | setRegistry (IRegistry *pRegistry)
| Set pointer to Registry. More...
IRegistry * | registry () const
| Get pointer to Registry. More...
LinkManager * | linkMgr () const
| Retrieve Link manager. More...
unsigned char | version () const
| Retrieve version number of this object representation. More...
void | setVersion (unsigned char vsn)
| Set version number of this object representation. More...
unsigned long | refCount () const
| Return the refcount. More...
virtual std::ostream & | fillStream (std::ostream &s) const
| Fill the output stream (ASCII) More...
Public Member Functions inherited from Gaudi::Generic1D< INTERFACE, IMPLEMENTATION >
| Generic1D ()=default
| Default constructor. More...
| ~Generic1D () override=default
| Default destructor. More...
virtual const std::string & | userLevelClassType () const
| The AIDA user-level unterface leaf class type. More...
void * | cast (const std::string &cl) const override
| Manual cast by class name. More...
TObject * | representation () const override
| ROOT object implementation. More...
std::string | title () const override
| Get the title of the object. More...
bool | setTitle (const std::string &title) override
| Set the title of the object. More...
std::string | name () const
| object name More...
bool | setName (const std::string &newName)
| Set the name of the object. More...
AIDA::IAnnotation & | annotation () override
| Access annotation object. More...
const AIDA::IAnnotation & | annotation () const override
| Access annotation object (cons) More...
Axis & | axis ()
| Access to axis object. More...
const Axis & | axis () const override
| Get the x axis of the IHistogram1D. More...
int | entries () const override
| Get the number or all the entries. More...
int | allEntries () const override
| Get the number or all the entries, both in range and underflow/overflow bins of the IProfile. More...
int | extraEntries () const override
| Get the number of entries in the underflow and overflow bins. More...
int | binEntries (int index) const override
| Number of entries in the corresponding bin (ie the number of times fill was called for this bin). More...
virtual double | binRms (int index) const
double | sumBinHeights () const override
| Get the sum of in range bin heights in the IProfile. More...
double | sumAllBinHeights () const override
| Get the sum of all the bins heights (including underflow and overflow bin). More...
double | sumExtraBinHeights () const override
| Get the sum of the underflow and overflow bin height. More...
double | minBinHeight () const override
| Get the minimum height of the in-range bins. More...
double | maxBinHeight () const override
| Get the maximum height of the in-range bins. More...
virtual double | equivalentBinEntries () const
| Number of equivalent entries, i.e. `SUM[ weight ] ^ 2 / SUM[ weight^2 ]` More...
virtual bool | scale (double scaleFactor)
| Scale the weights and the errors of all the IHistogram's bins (in-range and out-of-range ones) by a given scale factor. More...
bool | reset () override
| Reset the Histogram; as if just created. More...
bool | add (const INTERFACE &profile) override
| Modifies this IProfile1D by adding the contents of profile to it. More...
virtual int | rIndex (int index) const
| operator methods More...
double | binMean (int index) const override
| The weighted mean of a bin. More...
double | binHeight (int index) const override
| Total height of the corresponding bin (ie the sum of the weights in this bin). More...
double | binError (int index) const override
| The error of a given bin. More...
double | mean () const override
| The mean of the whole IHistogram1D. More...
double | rms () const override
| The RMS of the whole IHistogram1D. More...
int | coordToIndex (double coord) const override
| Get the bin number corresponding to a given coordinate along the x axis. More...
int | dimension () const override
| Get the Histogram's dimension. More...
std::ostream & | print (std::ostream &s) const override
| Print (ASCII) the histogram into the output stream. More...
std::ostream & | write (std::ostream &s) const override
| Write (ASCII) the histogram table into the output stream. More...
int | write (const char *file_name) const override
| Write (ASCII) the histogram table into a file. More...
template<>
void * | cast (const std::string &className) const
template<>
int | binEntries (int index) const
template<>
void | adoptRepresentation (TObject *rep)
| Adopt ROOT histogram representation. More...
template<>
int | binEntries (int index) const
template<>
void * | cast (const std::string &className) const
template<>
void | adoptRepresentation (TObject *rep)
| Adopt ROOT histogram representation. More...
Public Member Functions inherited from Gaudi::HistogramBase
virtual | ~HistogramBase ()=default

## Static Public Member Functions
static const CLID & | classID ()
Static Public Member Functions inherited from DataObject
static const CLID & | classID ()
| Retrieve reference to class definition structure (static access) More...

## Protected Attributes
double | m_sumwx = 0
| cache sumwx when setting contents since I don't have bin mean More...
Protected Attributes inherited from Gaudi::Generic1D< INTERFACE, IMPLEMENTATION >
Axis | m_axis
| Axis member. More...
AIDA::Annotation | m_annotation
| Object annotations. More...
std::unique_ptr< IMPLEMENTATION > | m_rep
| Reference to underlying implementation. More...
std::string | m_classType
int | m_sumEntries

## Private Member Functions
void | init (const std::string &title, bool initialize_axis=true)
void | initSums ()

## Additional Inherited Members
Public Types inherited from Gaudi::Generic1D< INTERFACE, IMPLEMENTATION >
typedef Generic1D< INTERFACE, IMPLEMENTATION > | Base
Protected Member Functions inherited from Gaudi::Generic1D< INTERFACE, IMPLEMENTATION >
| Generic1D (IMPLEMENTATION *p)
| constructor More...

## Detailed Description

AIDA implementation for 1 D histograms using ROOT THD1.

Author
  M.Frank

Definition at line 18 of file H1D.h.

## Constructor & Destructor Documentation

Gaudi::Histogram1D::Histogram1D | ( |  | ) |

Standard constructor.

Definition at line 65 of file H1D.cpp.

65 : Base( new TH1D() ) { init( "", false ); }
Gaudi::Histogram1D::init
void init(const std::string &title, bool initialize_axis=true)
Definition: H1D.cpp:74
Gaudi::Generic1D::Base
Generic1D< INTERFACE, IMPLEMENTATION > Base
Definition: Generic1D.h:39

Gaudi::Histogram1D::Histogram1D | ( | TH1D * | rep | ) |

Standard constructor with initialization. The histogram representation will be adopted.

Definition at line 67 of file H1D.cpp.

68 {
69 m_rep.reset( rep );
70 init( m_rep->GetTitle() );
71 initSums();
72 }
Gaudi::Histogram1D::initSums
void initSums()
Definition: H1D.cpp:88
Gaudi::Histogram1D::init
void init(const std::string &title, bool initialize_axis=true)
Definition: H1D.cpp:74
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
std::unique_ptr::reset
T reset(T...args)

## Member Function Documentation

void Gaudi::Histogram1D::adoptRepresentation | ( | TObject * | rep | ) |
| override virtual

Adopt ROOT histogram representation.

Reimplemented from Gaudi::Generic1D< INTERFACE, IMPLEMENTATION >.

Definition at line 106 of file H1D.cpp.

107 {
108 Gaudi::Generic1D<AIDA::IHistogram1D, TH1D>::adoptRepresentation( rep );
109 if ( m_rep ) {
110 init( m_rep->GetTitle() );
111 initSums();
112 }
113 }
Gaudi::Histogram1D::initSums
void initSums()
Definition: H1D.cpp:88
Gaudi::Histogram1D::init
void init(const std::string &title, bool initialize_axis=true)
Definition: H1D.cpp:74
Gaudi::Generic1D::adoptRepresentation
void adoptRepresentation(TObject *rep) override
Adopt ROOT histogram representation.
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134

static const CLID& Gaudi::Histogram1D::classID | ( |  | ) |
| inline static

Definition at line 50 of file H1D.h.

50 { return CLID_H1D; }

const CLID& Gaudi::Histogram1D::clID | ( |  | ) | const
| inline override virtual

Retrieve reference to class defininition identifier.

Reimplemented from DataObject.

Definition at line 49 of file H1D.h.

49 { return classID(); }
Gaudi::Histogram1D::classID
static const CLID & classID()
Definition: H1D.h:50

void Gaudi::Histogram1D::copyFromAida | ( | const AIDA::IHistogram1D & | h | ) |

Create new histogram from any AIDA based histogram.

Definition at line 172 of file H1D.cpp.

173 {
174 // implement here the copy
175 std::string tit = h.title() + "Copy";
176 if ( h.axis().isFixedBinning() ) {
177 m_rep.reset( new TH1D( tit.c_str(), tit.c_str(), h.axis().bins(), h.axis().lowerEdge(), h.axis().upperEdge() ) );
178 } else {
179 Edges e;
180 for ( int i = 0; i < h.axis().bins(); ++i ) {
181 e.push_back( h.axis().binLowerEdge( i ) );
182 }
183 // add also upperedges at the end
184 e.push_back( h.axis().upperEdge() );
185 m_rep.reset( new TH1D( tit.c_str(), tit.c_str(), e.size() - 1, &e.front() ) );
186 }
187 m_axis.initialize( m_rep->GetXaxis(), false );
188 m_rep->Sumw2();
189 m_sumEntries = 0;
190 m_sumwx = 0;
191 // sumw
192 double sumw = h.sumBinHeights();
193 // sumw2
194 double sumw2 = 0;
195 if ( h.equivalentBinEntries() != 0 ) sumw2 = ( sumw * sumw ) / h.equivalentBinEntries();
196
197 double sumwx = h.mean() * h.sumBinHeights();
198 double sumwx2 = ( h.mean() * h.mean() + h.rms() * h.rms() ) * h.sumBinHeights();
199
200 // copy the contents in
201 for ( int i = -2; i < axis().bins(); ++i ) {
202 // root binning starts from one !
203 m_rep->SetBinContent( rIndex( i ), h.binHeight( i ) );
204 m_rep->SetBinError( rIndex( i ), h.binError( i ) );
205 }
206 // need to do set entries after setting contents otherwise root will recalulate them
207 // taking into account how many time SetBinContents() has been called
208 m_rep->SetEntries( h.allEntries() );
209 // stat vector
210 std::vector<double> stat( 11 );
211 stat[0] = sumw;
212 stat[1] = sumw2;
213 stat[2] = sumwx;
214 stat[3] = sumwx2;
215 m_rep->PutStats( &stat.front() );
216 }
Gaudi::Edges
std::vector< double > Edges
Definition: GaudiPI.h:18
std::string
STL class.
Gaudi::Generic1D::axis
Axis & axis()
Access to axis object.
Definition: Generic1D.h:71
std::vector::push_back
T push_back(T...args)
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
HiveAlgSequencer.h
h
Definition: HiveAlgSequencer.py:24
Gaudi::Generic1D::m_axis
Axis m_axis
Axis member.
Definition: Generic1D.h:130
Gaudi::Axis::bins
int bins() const override
The number of bins (excluding underflow and overflow) on the IAxis.
Definition: Axis.h:95
std::unique_ptr::reset
T reset(T...args)
Gaudi::Generic1D::m_sumEntries
int m_sumEntries
Definition: Generic1D.h:138
std::vector< double >
Gaudi::Axis::initialize
void initialize(TAxis *itaxi, bool)
Definition: Axis.h:67
std::string::c_str
T c_str(T...args)
Gaudi::Generic1D::rIndex
virtual int rIndex(int index) const
operator methods
Definition: Generic1D.h:106
Gaudi::Histogram1D::m_sumwx
double m_sumwx
cache sumwx when setting contents since I don&#39;t have bin mean
Definition: H1D.h:26

bool Gaudi::Histogram1D::fill | ( | double | x,
|  | double | weight
| ) |  |
| override

Fill the Profile1D with a value and the corresponding weight.

Definition at line 166 of file H1D.cpp.

167 {
168 ( weight == 1. ) ? m_rep->Fill( x ) : m_rep->Fill( x, weight );
169 return true;
170 }
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134

void Gaudi::Histogram1D::init | ( | const std::string & | title,
|  | bool | initialize_axis = `true`
| ) |  |
| private

Definition at line 74 of file H1D.cpp.

75 {
76 m_classType = "IHistogram1D";
77 if ( initialize_axis ) {
78 m_axis.initialize( m_rep->GetXaxis(), false );
79 }
80 const TArrayD* a = m_rep->GetSumw2();
81 if ( !a || ( a && a->GetSize() == 0 ) ) m_rep->Sumw2();
82 setTitle( title );
83 m_rep->SetDirectory( nullptr );
84 m_sumEntries = 0;
85 m_sumwx = 0;
86 }
Gaudi::Generic1D::m_classType
std::string m_classType
Definition: Generic1D.h:136
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
Gaudi::Generic1D::setTitle
bool setTitle(const std::string &title) override
Set the title of the object.
Definition: Generic1D.h:142
Gaudi::Generic1D::m_axis
Axis m_axis
Axis member.
Definition: Generic1D.h:130
Gaudi::Generic1D::m_sumEntries
int m_sumEntries
Definition: Generic1D.h:138
Gaudi::Axis::initialize
void initialize(TAxis *itaxi, bool)
Definition: Axis.h:67
Gaudi::Histogram1D::m_sumwx
double m_sumwx
cache sumwx when setting contents since I don&#39;t have bin mean
Definition: H1D.h:26

void Gaudi::Histogram1D::initSums | ( |  | ) |
| private

Definition at line 88 of file H1D.cpp.

89 {
90 m_sumwx = 0;
91 m_sumEntries = 0;
92 for ( int i = 1, n = m_rep->GetNbinsX(); i <= n; ++i ) {
93 m_sumwx += m_rep->GetBinContent( i ) * m_rep->GetBinCenter( i );
94 m_sumEntries += m_rep->GetBinContent( i );
95 }
96 }
GaudiPluginService.cpluginsvc.n
n
Definition: cpluginsvc.py:228
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
Gaudi::Generic1D::m_sumEntries
int m_sumEntries
Definition: Generic1D.h:138
Gaudi::Histogram1D::m_sumwx
double m_sumwx
cache sumwx when setting contents since I don&#39;t have bin mean
Definition: H1D.h:26

bool Gaudi::Histogram1D::reset | ( |  | ) |
| override

need to overwrite reset to reset the sums

Definition at line 98 of file H1D.cpp.

99 {
100 m_sumwx = 0;
101 m_sumEntries = 0;
102 return Base::reset();
103 }
Gaudi::Generic1D::m_sumEntries
int m_sumEntries
Definition: Generic1D.h:138
Gaudi::Histogram1D::m_sumwx
double m_sumwx
cache sumwx when setting contents since I don&#39;t have bin mean
Definition: H1D.h:26

StreamBuffer & Gaudi::Histogram1D::serialize | ( | StreamBuffer & | s | ) |

Serialization mechanism, Serialize the object for reading.

Parameters

  s | the StreamBuffer containing the data to be read

Returns
  the resulting StreamBuffer, after reading

Definition at line 223 of file H1D.cpp.

224 {
225 // DataObject::serialize(s);
226 std::string title;
227 int size;
228 s >> size;
229 for ( int j = 0; j < size; j++ ) {
230 std::string key, value;
231 s >> key >> value;
232 annotation().addItem( key, value );
233 if ( "Title" == key ) {
234 title = value;
235 }
236 }
237 double lowerEdge, upperEdge, binHeight, binError;
238 int isFixedBinning, bins;
239 s >> isFixedBinning >> bins;
240
241 if ( isFixedBinning ) {
242 s >> lowerEdge >> upperEdge;
243 m_rep.reset( new TH1D( title.c_str(), title.c_str(), bins, lowerEdge, upperEdge ) );
244 } else {
245 Edges edges;
246 edges.resize( bins );
247 for ( int i = 0; i <= bins; ++i ) s >> *(double*)&edges[i];
248 m_rep.reset( new TH1D( title.c_str(), title.c_str(), edges.size() - 1, &edges.front() ) );
249 }
250 m_axis.initialize( m_rep->GetXaxis(), true );
251 m_rep->Sumw2();
252 m_sumEntries = 0;
253 m_sumwx = 0;
254
255 for ( int i = 0; i <= bins + 1; ++i ) {
256 s >> binHeight >> binError;
257 m_rep->SetBinContent( i, binHeight );
258 m_rep->SetBinError( i, binError );
259 }
260 Stat_t allEntries;
261 s >> allEntries;
262 m_rep->SetEntries( allEntries );
263 Stat_t stats[4]; // stats array
264 s >> stats[0] >> stats[1] >> stats[2] >> stats[3];
265 m_rep->PutStats( stats );
266 return s;
267 }
Gaudi::Generic1D::title
std::string title() const override
Get the title of the object.
Definition: Generic1D.h:59
Gaudi::Generic1D::binHeight
double binHeight(int index) const override
Total height of the corresponding bin (ie the sum of the weights in this bin).
Definition: Generic1D.h:171
Gaudi::Edges
std::vector< double > Edges
Definition: GaudiPI.h:18
std::vector::resize
T resize(T...args)
Gaudi::Generic1D::binError
double binError(int index) const override
The error of a given bin.
Definition: Generic1D.h:177
std::string
STL class.
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
Gaudi::Generic1D::allEntries
int allEntries() const override
Get the number or all the entries, both in range and underflow/overflow bins of the IProfile...
Definition: Generic1D.h:78
Gaudi::Generic1D::m_axis
Axis m_axis
Axis member.
Definition: Generic1D.h:130
std::unique_ptr::reset
T reset(T...args)
Gaudi::Generic1D::m_sumEntries
int m_sumEntries
Definition: Generic1D.h:138
Gaudi::Axis::initialize
void initialize(TAxis *itaxi, bool)
Definition: Axis.h:67
std::string::c_str
T c_str(T...args)
gaudirun.s
string s
Definition: gaudirun.py:253
Gaudi::Generic1D::annotation
AIDA::IAnnotation & annotation() override
Access annotation object.
Definition: Generic1D.h:67
Gaudi::Histogram1D::m_sumwx
double m_sumwx
cache sumwx when setting contents since I don&#39;t have bin mean
Definition: H1D.h:26

StreamBuffer & Gaudi::Histogram1D::serialize | ( | StreamBuffer & | s | ) | const

Serialization mechanism, Serialize the object for writing.

Parameters

  s | the StreamBuffer where to write the data

Returns
  the resulting StreamBuffer, after wrinting

Definition at line 269 of file H1D.cpp.

270 {
271 // DataObject::serialize(s);
272 s << static_cast<int>( annotation().size() );
273 for ( int i = 0; i < annotation().size(); i++ ) {
274 s << annotation().key( i );
275 s << annotation().value( i );
276 }
277 const AIDA::IAxis& axis( this->axis() );
278 const int isFixedBinning = axis.isFixedBinning();
279 const int bins = axis.bins();
280 s << isFixedBinning << bins;
281 if ( isFixedBinning ) {
282 s << axis.lowerEdge();
283 } else {
284 for ( int i = 0; i < bins; ++i ) s << axis.binLowerEdge( i );
285 }
286 s << axis.upperEdge();
287 for ( int i = 0; i <= bins + 1; ++i ) s << m_rep->GetBinContent( i ) << m_rep->GetBinError( i );
288
289 s << m_rep->GetEntries();
290 Stat_t stats[4]; // stats array
291 m_rep->GetStats( stats );
292 s << stats[0] << stats[1] << stats[2] << stats[3];
293 return s;
294 }
Gaudi::Axis::isFixedBinning
bool isFixedBinning() const override
Check if the IAxis has fixed binning, i.e.
Definition: Axis.h:74
Gaudi::Generic1D::axis
Axis & axis()
Access to axis object.
Definition: Generic1D.h:71
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
Gaudi::Axis::bins
int bins() const override
The number of bins (excluding underflow and overflow) on the IAxis.
Definition: Axis.h:95
Gaudi::Axis::binLowerEdge
double binLowerEdge(int index) const override
Get the lower edge of the specified bin.
Definition: Axis.h:104
Gaudi::Axis::lowerEdge
double lowerEdge() const override
Get the lower edge of the IAxis.
Definition: Axis.h:81
gaudirun.s
string s
Definition: gaudirun.py:253
Gaudi::Generic1D::annotation
AIDA::IAnnotation & annotation() override
Access annotation object.
Definition: Generic1D.h:67
Gaudi::Axis::upperEdge
double upperEdge() const override
Get the upper edge of the IAxis.
Definition: Axis.h:88

bool Gaudi::Histogram1D::setBinContents | ( | int | i,
|  | int | entries,
|  | double | height,
|  | double | error,
|  | double | centre
| ) |  |
| virtual

set bin content (entries and centre are not used )

Definition at line 115 of file H1D.cpp.

116 {
117 m_rep->SetBinContent( rIndex( i ), height );
118 m_rep->SetBinError( rIndex( i ), error );
119 // accumulate sumwx for in range bins
120 if ( i != AIDA::IAxis::UNDERFLOW_BIN && i != AIDA::IAxis::OVERFLOW_BIN ) m_sumwx += centre * height;
121 m_sumEntries += entries;
122 return true;
123 }
Gaudi::Generic1D::entries
int entries() const override
Get the number or all the entries.
Definition: Generic1D.h:76
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
Gaudi::Generic1D::m_sumEntries
int m_sumEntries
Definition: Generic1D.h:138
Gaudi::Generic1D::rIndex
virtual int rIndex(int index) const
operator methods
Definition: Generic1D.h:106
Gaudi::Histogram1D::m_sumwx
double m_sumwx
cache sumwx when setting contents since I don&#39;t have bin mean
Definition: H1D.h:26

bool Gaudi::Histogram1D::setRms | ( | double | rms | ) |

Update histogram RMS.

Definition at line 131 of file H1D.cpp.

132 {
133 m_rep->SetEntries( m_sumEntries );
134 std::vector<double> stat( 11 );
135 // sum weights
136 stat[0] = sumBinHeights();
137 stat[1] = 0;
138 if ( equivalentBinEntries() != 0 ) stat[1] = ( sumBinHeights() * sumBinHeights() ) / equivalentBinEntries();
139 stat[2] = m_sumwx;
140 double mean = 0;
141 if ( sumBinHeights() != 0 ) mean = m_sumwx / sumBinHeights();
142 stat[3] = ( mean * mean + rms * rms ) * sumBinHeights();
143 m_rep->PutStats( &stat.front() );
144 return true;
145 }
Gaudi::Generic1D::sumBinHeights
double sumBinHeights() const override
Get the sum of in range bin heights in the IProfile.
Definition: Generic1D.h:86
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
Gaudi::Generic1D::rms
double rms() const override
The RMS of the whole IHistogram1D.
Definition: Generic1D.h:116
Gaudi::Generic1D::m_sumEntries
int m_sumEntries
Definition: Generic1D.h:138
std::vector< double >
Gaudi::Generic1D::equivalentBinEntries
virtual double equivalentBinEntries() const
Number of equivalent entries, i.e. SUM[ weight ] ^ 2 / SUM[ weight^2 ]
Definition: Generic1D.h:196
Gaudi::Generic1D::mean
double mean() const override
The mean of the whole IHistogram1D.
Definition: Generic1D.h:114
Gaudi::Histogram1D::m_sumwx
double m_sumwx
cache sumwx when setting contents since I don&#39;t have bin mean
Definition: H1D.h:26

bool Gaudi::Histogram1D::setStatistics | ( | int | allEntries,
|  | double | eqBinEntries,
|  | double | mean,
|  | double | rms
| ) |  |
| virtual

set histogram statistics

Definition at line 148 of file H1D.cpp.

149 {
150 m_rep->SetEntries( allEntries );
151 // fill statistcal vector for Root
152 std::vector<double> stat( 11 );
153 // sum weights
154 stat[0] = sumBinHeights();
155 // sum weights **2
156 stat[1] = 0;
157 if ( eqBinEntries != 0 ) stat[1] = ( sumBinHeights() * sumBinHeights() ) / eqBinEntries;
158 // sum weights * x
159 stat[2] = mean * sumBinHeights();
160 // sum weight * x **2
161 stat[3] = ( mean * mean + rms * rms ) * sumBinHeights();
162 m_rep->PutStats( &stat.front() );
163 return true;
164 }
Gaudi::Generic1D::sumBinHeights
double sumBinHeights() const override
Get the sum of in range bin heights in the IProfile.
Definition: Generic1D.h:86
Gaudi::Generic1D::m_rep
std::unique_ptr< IMPLEMENTATION > m_rep
Reference to underlying implementation.
Definition: Generic1D.h:134
Gaudi::Generic1D::allEntries
int allEntries() const override
Get the number or all the entries, both in range and underflow/overflow bins of the IProfile...
Definition: Generic1D.h:78
Gaudi::Generic1D::rms
double rms() const override
The RMS of the whole IHistogram1D.
Definition: Generic1D.h:116
std::vector< double >
Gaudi::Generic1D::mean
double mean() const override
The mean of the whole IHistogram1D.
Definition: Generic1D.h:114

## Member Data Documentation

double Gaudi::Histogram1D::m_sumwx = 0
| protected

cache sumwx when setting contents since I don't have bin mean

Definition at line 26 of file H1D.h.

The documentation for this class was generated from the following files:

- GaudiCommonSvc/GaudiCommonSvc/H1D.h
- GaudiCommonSvc/src/HistogramSvc/H1D.cpp